//
// File: General purpose parser for WinSock Client and Server
//

#include "sockutil.h"

//
// Usage - exits the program
//
int Usage()
{
    printf ("\n");
    printf ("wget -? | [-f <file>] [-h] <url>\n");
    printf ("     -f file in which the web-page is saved\n");
    printf ("     -h optionally save http header-records\n");
    printf ("     -? this help-message\n");
    exit(1);
    return(1); // quiets the compiler
}

//
// Command line parser
//
void ParseCmdLine (int argc, char ** argv, 
                   char * szUrl, char * szFileName, BOOL * pbHeaderRecs)
{
    int i, j;

    argc--;
    argv++;
    while (argc)
    {
        if (argv[0][0] == '-')
        {
            switch (argv[0][1])
            {
            case '?':
                Usage();
            case 'f':
                argc--;
                argv++;
                strcpy(szFileName, argv[0]);
                break;
            case 'h':
                *pbHeaderRecs = TRUE;
                break;
            default:
                Usage();
            }
        }
        else
        {
            strcpy(szUrl, argv[0]);
            break;
        }
        argc--;
        argv++;
    }
    
    // if user didn't specify url
    if (strcmp (szUrl, "") == 0)
        Usage();

    // if user specified hostname, but no ending slash
    if (strchr (szUrl, '/') == NULL)
        strcat (szUrl, "/");

    // set filename to use for saving file
    if (strcmp (szFileName, "") == 0)
    {
        for (i = 0, j = 0; i <= (int) strlen(szUrl); i++, j++)
        {
            if (szUrl[i] == '/')
                j = -1;
            else
                szFileName[j] = szUrl[i];
        }
    }
    // if url didn't end in filename
    if (strcmp (szFileName, "") == 0)
        strcpy (szFileName, "index.html");
        
    return;
}

//
// URL parser
//
void ParseHttpUrl (char * szUrl, char * szFileName,
                   char * szHostName, char * szPathName, int * piPortNumber)
{
    char *p;

    char szTmpUrl[MAX_PATH];
    
    strcpy (szTmpUrl, szUrl);

    // if user started url with http://
    if (strncmp (szUrl, "http://", 7) == 0)
        strcpy (szTmpUrl, &szTmpUrl[7]);

    // extract hostname (plus portnumber) and pathname
    strcpy (szHostName, szTmpUrl);
    strcpy (szPathName, "/");
    if ((p = strchr (szHostName, '/')) != NULL)
    {
        strcpy (szPathName, p);
        *strchr (szHostName, '/') = '\0';
    }

    // extract portnumber
    *piPortNumber = 80;
    if ((p = strchr (szHostName, ':')) != NULL)
    {
        sscanf ((p + 1), "%d", piPortNumber);
        *strchr (szHostName, ':') = '\0';        
    }
        
    return;
}


